%global heketiver 6.0.0
%global gkver     1.2.0
%global templatedir heketi

Name:		cns-deploy
Version:	%{heketiver}
Release:        5%{?dist}
Summary:        Container-Native Storage deployment tool
License:        ASL 2.0
Provides:       heketi-templates = %{version}-%{release}
Obsoletes:      heketi-templates < %{version}-%{release}
URL:		https://github.com/gluster/gluster-kubernetes
Source0:	https://github.com/gluster/gluster-kubernetes/archive/v%{gkver}.tar.gz

# Patches ported from upstream gluster-kubernetes:
Patch0001:      0001-gk-deploy-Set-rebalance_on_expansion-true-for-heketi.patch
patch0002:      0002-gk-deploy-Deploy-gluster-s3-container.patch
Patch0003:      0003-gk-deploy-Set-resource-requests-for-GlusterFS-pod.patch
Patch0004:      0004-Added-new-env.-variable-GB_GLFS_LRU_COUNT.patch
Patch0005:      0005-Update-tcmu-runner-s-log-directory-using-env.-variab.patch
Patch0006:      0006-Fix-TCMU-log-directory-name-as-TCMU_LOGDIR.patch
Patch0007:      0007-fix-typo-for-executor-type.patch
Patch0008:      0008-when-using-ssh-executor-provide-etc-fstab-as-ENV.patch
Patch0009:      0009-provide-flags-before-env-var.patch
Patch0010:      0010-fstab-var-contains-slash.patch
Patch0011:      0011-Fix-default-value-for-GB_GLFS_LRU_COUNT.patch
Patch0012:      0012-increase-failure-threshold-for-glusterfs-pods.patch
Patch0013:      0013-Don-t-try-to-forward-terminal-to-kubectl-exec-calls.patch
Patch0014:      0014-Add-HEKETI_IGNORE_STALE_OPERATIONS-env-variable-in-h.patch

# CNS-specific patches
Patch1000:      1000-gk-deploy-Deploy-glusterblock-provisioner-container.patch
Patch1001:      1001-use-downstream-gluster-image.patch
Patch1002:      1002-use-downstream-image-of-heketi.patch
Patch1003:      1003-Use-downstream-volmanager-image-for-deploy-heketi.patch
Patch1004:      1004-add-image-name-for-heketi-container.patch
Patch1005:      1005-Use-downstream-location-for-heketi.json.template.patch
Patch1006:      1006-Set-downstream-BLOCK_HOST_SIZE-default-to-500.patch
Patch1007:      1007-use-downstream-glusterblock-provisioner-image.patch
Patch1008:      1008-use-downstream-gluster-S3-server-image.patch

Requires:	python


%description
%{name} is a tool to facilitate the deployment of a Container-Native Storage
solution using GlusterFS.


%prep
%setup -n gluster-kubernetes-%{gkver}


# upstream gluster-kubernetes patches:
%patch0001 -p1 -b .0001-gk-deploy-Set-rebalance_on_expansion-true-for-heketi.patch
%patch0002 -p1 -b .0002-gk-deploy-Deploy-gluster-s3-container.patch
%patch0003 -p1 -b .0003-gk-deploy-Set-resource-requests-for-GlusterFS-pod.patch
%patch0004 -p1 -b .0004-Added-new-env.-variable-GB_GLFS_LRU_COUNT.patch
%patch0005 -p1 -b .0005-Update-tcmu-runner-s-log-directory-using-env.-variab.patch
%patch0006 -p1 -b .0006-Update-tcmu-runner-s-log-directory-using-env.-variab.patch
%patch0007 -p1 -b .0007-fix-typo-for-executor-type.patch
%patch0008 -p1 -b .0008-when-using-ssh-executor-provide-etc-fstab-as-ENV.patch
%patch0009 -p1 -b .0009-provide-flags-before-env-var.patch
%patch0010 -p1 -b .0010-fstab-var-contains-slash.patch
%patch0011 -p1 -b .0011-Fix-default-value-for-GB_GLFS_LRU_COUNT.patch
%patch0012 -p1 -b .0012-increase-failure-threshold-for-glusterfs-pods.patch
%patch0013 -p1 -b .0013-Don-t-try-to-forward-terminal-to-kubectl-exec-calls.patch
%patch0014 -p1 -b .0014-Add-HEKETI_IGNORE_STALE_OPERATIONS-env-variable-in-h.patch

# CNS-specific patches
%patch1000 -p1 -b .1000-gk-deploy-Deploy-glusterblock-provisioner-container.patch
%patch1001 -p1 -b .1001-use-downstream-gluster-image.patch
%patch1002 -p1 -b .1002-use-downstream-image-of-heketi.patch
%patch1003 -p1 -b .1003-Use-downstream-volmanager-image-for-deploy-heketi.patch
%patch1004 -p1 -b .1004-add-image-name-for-heketi-container.patch
%patch1005 -p1 -b .1005-Use-downstream-location-for-heketi.json.template.patch
%patch1006 -p1 -b .1006-Set-downstream-BLOCK_HOST_SIZE-default-to-500.patch
%patch1007 -p1 -b .1007-use-downstream-glusterblock-provisioner-image.patch
%patch1008 -p1 -b .1008-use-downstream-gluster-S3-server-image.patch


sed -i 's#\${SCRIPT_DIR}/ocp-templates#%{_datadir}/%{templatedir}/templates#' deploy/gk-deploy


%install
install -D -p -m 0755 deploy/gk-deploy %{buildroot}%{_bindir}/cns-deploy
install -D -p -m 0644 deploy/ocp-templates/glusterfs-template.yaml \
  %{buildroot}%{_datadir}/%{templatedir}/templates/glusterfs-template.yaml
install -D -p -m 0644 deploy/ocp-templates/heketi-template.yaml \
  %{buildroot}%{_datadir}/%{templatedir}/templates/heketi-template.yaml
install -D -p -m 0644 deploy/ocp-templates/heketi-service-account.yaml \
  %{buildroot}%{_datadir}/%{templatedir}/templates/heketi-service-account.yaml
install -D -p -m 0644 deploy/ocp-templates/deploy-heketi-template.yaml \
  %{buildroot}%{_datadir}/%{templatedir}/templates/deploy-heketi-template.yaml

install -D -p -m 0644 deploy/ocp-templates/glusterblock-provisioner.yaml \
  %{buildroot}%{_datadir}/%{templatedir}/templates/glusterblock-provisioner.yaml

install -D -p -m 0644 deploy/ocp-templates/gluster-s3-pvcs.yaml \
  %{buildroot}%{_datadir}/%{templatedir}/templates/gluster-s3-pvcs.yaml
install -D -p -m 0644 deploy/ocp-templates/gluster-s3-storageclass.yaml \
  %{buildroot}%{_datadir}/%{templatedir}/templates/gluster-s3-storageclass.yaml
install -D -p -m 0644 deploy/ocp-templates/gluster-s3-template.yaml \
  %{buildroot}%{_datadir}/%{templatedir}/templates/gluster-s3-template.yaml

install -D -p -m 0644 deploy/heketi.json.template \
  %{buildroot}%{_datadir}/%{templatedir}/templates/heketi.json.template

install -D -p -m 0644 docs/examples/sample-gluster-endpoints.yaml \
  %{buildroot}%{_datadir}/%{templatedir}/templates/sample-gluster-endpoints.yaml
install -D -p -m 0644 docs/examples/sample-gluster-service.yaml \
  %{buildroot}%{_datadir}/%{templatedir}/templates/sample-gluster-service.yaml



%files
%license LICENSE
%doc README.md
%{_datadir}/%{templatedir}/templates/*
%{_bindir}/cns-deploy


%changelog
* Tue Mar 06 2018  Raghavendra Talur <rtalur@redhat.com> - 6.0.0-5
- Resolves: #1548322 - panic: Heketi terminated while performing one or more operations. Server will not start as long as pending operations are present in the db.

* Mon Mar 05 2018  Raghavendra Talur <rtalur@redhat.com> - 6.0.0-4
- Resolves: #1548322 - panic: Heketi terminated while performing one or more operations. Server will not start as long as pending operations are present in the db.

* Thu Feb 22 2018  Raghavendra Talur <rtalur@redhat.com> - 6.0.0-3
- Resolves: #1547917 - [RFE] Rebase heketi to Heketi v6 upstream source

* Wed Feb 21 2018  Raghavendra Talur <rtalur@redhat.com> - 6.0.0-2
- Resolves: #1535945  - Support CNS 3.9 upgrade

* Wed Feb 21 2018  Saravanakumar Arumugam <sarumuga@redhat.com> - 6.0.0-1
- Resolves: #1505948 - Don't try to forward terminal to kubectl exec calls

* Thu Oct 05 2017  Raghavendra Talur <rtalur@redhat.com> - 5.0.0-54
- Resolves: #1498543 - after upgrade from cns 3.5 to 3.6, heketi block-provisioning fails

* Wed Oct 04 2017  Raghavendra Talur <rtalur@redhat.com> - 5.0.0-53
- Resolves: #1497946 - after upgrade from cns 3.5 to 3.6, volume creation fails

* Fri Sep 29 2017  Raghavendra Talur <rtalur@redhat.com> - 5.0.0-52
- Resolves: #1497125 - sample file for static provisioning of glusterfs volumes are missing

* Tue Sep 26 2017  Raghavendra Talur <rtalur@redhat.com> - 5.0.0-51
- Resolves: #1495838 - glusterblock-provisioner image name seems to have changed recently and hence needs to be updated in the glusterblock-provisioner.yaml template

* Fri Sep 22 2017  Raghavendra Talur <rtalur@redhat.com> - 5.0.0-50
- Resolves: #1494339 - Heketi pod stops working when being restarted or deleted
- Resolves: #1494270 - Cannot deploy CNS with rhgs-server-rhel7 image > 3.3.0-15 due to missing environment variables GB_GLFS_LRU_COUNT, TCMU_LOGDIR

* Wed Sep 20 2017  Raghavendra Talur <rtalur@redhat.com> - 5.0.0-49
- Resolves: #1490980 - Heketi pod stops working when beging restarted or deleted

* Wed Sep 20 2017  Raghavendra Talur <rtalur@redhat.com> - 5.0.0-48
- Resolves: #1490980 - Heketi pod stops working when beging restarted or deleted

* Tue Sep 19 2017  Saravanakumar Arumugam <sarumuga@redhat.com> - 5.0.0-47
- Resolves: #1491177 - base version of rhgs image says RHEL 7.4 Beta instead of RHEL 7.4

* Mon Sep 18 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-46
- Resolves: #1487645 - block-volume creation fails when one of the node is down in a 3 node RHGS cluster
- Resolves: #1492533 - dynamic provisioning of block-volume creation fails

* Mon Sep 18 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-45
- Resolves: #1487645 - block-volume creation fails when one of the node is down in a 3 node RHGS cluster
- Resolves: #1492533 - dynamic provisioning of block-volume creation fails

* Mon Sep 18 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-44
- Resolves: #1491181 - base version of glusterblock-provisioner image says RHEL 7.4 Beta instead of RHEL 7.4

* Mon Sep 18 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-43
- Resolves: #1487645 - block-volume creation fails when one of the node is down in a 3 node RHGS cluster

* Sun Sep 17 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-42
- Resolves: #1487645 - block-volume creation fails when one of the node is down in a 3 node RHGS cluster

* Fri Sep 15 2017 Saravanakumar Arumugam <sarumuga@redhat.com> - 5.0.0-41
- Resolves: #1470521  gluster-block logs should be persisted

* Thu Sep 14 2017 Saravanakumar Arumugam <sarumuga@redhat.com> - 5.0.0-40
- Resolves: #1491176 	base version of heketi volmanager image says RHEL 7.4 Beta instead of RHEL 7.4
- Resolves: #1491177 	base version of rhgs image says RHEL 7.4 Beta instead of RHEL 7.4
- Resolves: #1491181 	base version of glusterblock-provisioner image says RHEL 7.4 Beta instead of RHEL 7.4
- Resolves: #1491282    base version of rhgs-s3-server image says RHEL 7.4 Beta instead of RHEL 7.4

* Thu Sep 14 2017 Saravanakumar Arumugam <sarumuga@redhat.com> - 5.0.0-39
- Resolves: #1491176 	base version of heketi volmanager image says RHEL 7.4 Beta instead of RHEL 7.4
- Resolves: #1491177 	base version of rhgs image says RHEL 7.4 Beta instead of RHEL 7.4
- Resolves: #1491181 	base version of glusterblock-provisioner image says RHEL 7.4 Beta instead of RHEL 7.4
- Resolves: #1491282    base version of rhgs-s3-server image says RHEL 7.4 Beta instead of RHEL 7.4

* Wed Sep 13 2017 Saravanakumar Arumugam <sarumuga@redhat.com> - 5.0.0-38
- Resolves: #1487620 - [CNS-Gluster-block]: tcmu-runner logs should be configurable

* Tue Sep 12 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-37
- Resolves: #1490700 - cns-deploy failed: error while deploying deploy-heketi-pod

* Tue Sep 12 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-36
- Resolves: #1490700 - cns-deploy failed: error while deploying deploy-heketi-pod

* Tue Sep 12 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-35
- Resolves: #1487514 - fstab entry is missing in heketi.json file

* Fri Sep 08 2017 Jose A. Rivera <jarrpa@redhat.com> - 5.0.0-34
- Fix typo in block prov image
- Resolves: #1489860 - s3 and block provisioner templates refer to upstream images

* Fri Sep 08 2017 Jose A. Rivera <jarrpa@redhat.com> - 5.0.0-33
- Add missing downstream image references
- Resolves: #1489860 - s3 and block provisioner templates refer to upstream images

* Wed Sep 06 2017 Jose A. Rivera <jarrpa@redhat.com> - 5.0.0-32
- Correct apiVersions for OCP templates
- Resolves: #1489098 - [cns] gluster-block creation via dynamic provisioning fails

* Wed Sep 06 2017 Jose A. Rivera <jarrpa@redhat.com> - 5.0.0-31
- Update upstream patches
- Resolves: #1487987 - cns-deployment fails

* Tue Sep 05 2017 Jose A. Rivera <jarrpa@redhat.com> - 5.0.0-30
- Update upstream patches
- Resolves: #1487620 - [CNS-Gluster-block]: tcmu-runner logs should be configurable
- Resolves: #1487987 - cns-deployment fails
- Resolves: #1488122 - [cns-deploy]: gluster-block setup fails

* Sat Sep 02 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-29
- Resolves: #1478046 - /etc/sysconfig/gluster-block file, which defines 'GB_GLFS_LRU_COUNT' value, should be persistent in RHGS image
- Resolves: #1487620 - [CNS-Gluster-block]: tcmu-runner logs should be configurable

* Fri Sep 01 2017 Jose A. Rivera <jarrpa@redhat.com> - 5.0.0-28
- Fix patch files
- Resolves: #1480124 - [RFE] Support Block Provisioner and S3 template deployment via cns-deploy tool

* Fri Sep 01 2017 Jose A. Rivera <jarrpa@redhat.com> - 5.0.0-27
- Add missing files
- Resolves: #1480124 - [RFE] Support Block Provisioner and S3 template deployment via cns-deploy tool

* Thu Aug 31 2017 Jose A. Rivera <jarrpa@redhat.com> - 5.0.0-26
- Resolves: #1480124 - [RFE] Support Block Provisioner and S3 template deployment via cns-deploy tool

* Tue Aug 29 2017 Saravanakumar Arumugam <saramuga@redhat.com> - 5.0.0-25
- Resolves: #1480528 - Rename parameters passed to rhgs-s3-server container

* Fri Aug 25 2017 Jose A. Rivera <jarrpa@redhat.com> - 5.0.0-24
- Add missing heketi.json config
- Resolves: #1485211 - auto block-hosting volume creation is disabled

* Thu Aug 24 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-23
- Resolves: #1484871 - target service doesn't start as /etc/target/saveconfig.json file is not available

* Thu Aug 24 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-22
- Resolves: #1484871 - target service doesn't start as /etc/target/saveconfig.json file is not available

* Thu Aug 24 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-21
- Resolves: #1483038 - cns-deployment fails at deploy-heketi phase

* Wed Aug 23 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-20
- Resolves: #1483038 - cns-deployment fails at deploy-heketi phase

* Mon Aug 21 2017 Mohamed Ashiq Liyazudeen <mliyazud@redhat.com> - 5.0.0-19
- Resolves: #1483038 - cns-deployment fails at deploy-heketi phase

* Fri Aug 18 2017 Mohamed Ashiq Liyazudeen <mliyazud@redhat.com> - 5.0.0-18
- Resolves: #1481619 - When a node hosting gluster-block devices is rebooted, further discovery fails on that node

* Fri Aug 18 2017 Mohamed Ashiq Liyazudeen <mliyazud@redhat.com> - 5.0.0-17
- Resolves: #1481619 - When a node hosting gluster-block devices is rebooted, further discovery fails on that node

* Fri Aug 18 2017 Mohamed Ashiq Liyazudeen <mliyazud@redhat.com> - 5.0.0-16
- Resolves: #1481619 - When a node hosting gluster-block devices is rebooted, further discovery fails on that node

* Sat Aug 12 2017 Mohamed Ashiq Liyazudeen <mliyazud@redhat.com> - 5.0.0-15
- Resolves: #1480332 - Gluster Bricks are not coming up after pod restart when bmux is ON
- Resolves: #1480528 - Rename parameters passed  to rhgs-s3-server container

* Wed Aug 09 2017 Mohamed Ashiq Liyazudeen <mliyazud@redhat.com> - 5.0.0-14
- Resolves: #1477020 - [Tracker Bug (RHGS)] when gluster pod is restarted, bricks from the restarted pod fails to connect to fuse, self-heal etc

* Tue Aug 08 2017 Mohamed Ashiq Liyazudeen <mliyazud@redhat.com> - 5.0.0-13
- Resolves: #1477431 - After Volume Expansion is completed successfully getting write error inside the volume

* Wed Jul 26 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-12
- Resolves: #1468106 - mark heketi-client package as a dependent of cns-deploy
                       for upgrades as well

* Wed Jul 26 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-11
- Resolves: #1468106 - mark heketi-client package as a dependent of cns-deploy
                       for upgrades as well

* Wed Jul 26 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-10
- Resolves: #1468106 - mark heketi-client package as a dependent of cns-deploy
                       for upgrades as well

* Wed Jul 26 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-9
- Resolves: #1468106 - mark heketi-client package as a dependent of cns-deploy
                       for upgrades as well

* Wed Jul 12 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-8
- Resolves: #1470142 - cns-deploy doesn't have latest image tags updated in its
                       templates

* Wed Jul 12 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-7
- Resolves: #1469360 - Initiators fail to detect gluster-block target
- Resolves: #1468110 - Include Gluster Block Provisioner depoyment artifacts in
                       cns-deploy package.
- Resolves: #1465378 - template file for rhgs-s3-server


* Fri Jul 07 2017 Mohamed Ashiq Liyazudeen <mliyazud@redhat.com> - -6
- Resolves: #1468428 - unable to add device via heketi
- Resolves: #1468109 - provide a heketi image with auto_create_block_hosting_volume enabled by default

* Tue Jul 04 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-5
- Resolves: #1467318 -  Getting proxy error while deploying heketi pod(pod
                        restarted)

* Thu Jun 29 2017 Mohamed Ashiq Liyazudeen <mliyazud@redhat.com> - 5.0.0-4
- Resolves:  #1456761 - cns-deploy rebase on 1.2v
* Mon Jun 19 2017 Mohamed Ashiq Liyazudeen <mliyazud@redhat.com> - 5.0.0-3
- Resolves:  #1456761 - cns-deploy rebase on 1.2v
* Fri Jun 9 2017 Mohamed Ashiq Liyazudeen <mliyazud@redhat.com> - 5.0.0-2
- Resolves:  #1459810 - heketi-storage-copy-job fails during cns-deploy as it trying to pull a wrong image "heketi/heketi:dev"
* Mon May 29 2017 Raghavendra Talur <rtalur@redhat.com>, Mohamed Ashiq Liyazudeen <mliyazud@redhat.com> - 5.0.0-1
- Resolves:  #1456761 - cns-deploy rebase on 1.2v
